/* Generated by wayland-scanner 1.23.0 */

#ifndef BUDGIE_KEYBOARD_SHORTCUTS_SERVER_PROTOCOL_H
#define BUDGIE_KEYBOARD_SHORTCUTS_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_budgie_keyboard_shortcuts The budgie_keyboard_shortcuts protocol
 * Budgie-specific protocol
 *
 * @section page_desc_budgie_keyboard_shortcuts Description
 *
 * This is a private Budgie Desktop protocol. Regular Wayland clients must not use it.
 *
 * This protocol is currently unversioned and may change without notice.
 *
 * @section page_ifaces_budgie_keyboard_shortcuts Interfaces
 * - @subpage page_iface_budgie_keyboard_shortcuts_manager - 
 * - @subpage page_iface_budgie_keyboard_shortcuts_subscriber - 
 * @section page_copyright_budgie_keyboard_shortcuts Copyright
 * <pre>
 *
 * Copyright Budgie Desktop Developers
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * </pre>
 */
struct budgie_keyboard_shortcuts_manager;
struct budgie_keyboard_shortcuts_subscriber;

#ifndef BUDGIE_KEYBOARD_SHORTCUTS_MANAGER_INTERFACE
#define BUDGIE_KEYBOARD_SHORTCUTS_MANAGER_INTERFACE
/**
 * @page page_iface_budgie_keyboard_shortcuts_manager budgie_keyboard_shortcuts_manager
 * @section page_iface_budgie_keyboard_shortcuts_manager_api API
 * See @ref iface_budgie_keyboard_shortcuts_manager.
 */
/**
 * @defgroup iface_budgie_keyboard_shortcuts_manager The budgie_keyboard_shortcuts_manager interface
 */
extern const struct wl_interface budgie_keyboard_shortcuts_manager_interface;
#endif
#ifndef BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_INTERFACE
#define BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_INTERFACE
/**
 * @page page_iface_budgie_keyboard_shortcuts_subscriber budgie_keyboard_shortcuts_subscriber
 * @section page_iface_budgie_keyboard_shortcuts_subscriber_api API
 * See @ref iface_budgie_keyboard_shortcuts_subscriber.
 */
/**
 * @defgroup iface_budgie_keyboard_shortcuts_subscriber The budgie_keyboard_shortcuts_subscriber interface
 */
extern const struct wl_interface budgie_keyboard_shortcuts_subscriber_interface;
#endif

/**
 * @ingroup iface_budgie_keyboard_shortcuts_manager
 * @struct budgie_keyboard_shortcuts_manager_interface
 */
struct budgie_keyboard_shortcuts_manager_interface {
	/**
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * Subscribe to keyboard shortcut events
	 *
	 * 
	 */
	void (*subscribe)(struct wl_client *client,
			  struct wl_resource *resource,
			  uint32_t id);
};


/**
 * @ingroup iface_budgie_keyboard_shortcuts_manager
 */
#define BUDGIE_KEYBOARD_SHORTCUTS_MANAGER_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_budgie_keyboard_shortcuts_manager
 */
#define BUDGIE_KEYBOARD_SHORTCUTS_MANAGER_SUBSCRIBE_SINCE_VERSION 1

/**
 * @ingroup iface_budgie_keyboard_shortcuts_subscriber
 * @struct budgie_keyboard_shortcuts_subscriber_interface
 */
struct budgie_keyboard_shortcuts_subscriber_interface {
	/**
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * Register a shortcut
	 *
	 * 
	 */
	void (*register_shortcut)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t modifiers,
				  uint32_t keycode);
	/**
	 * Unregister a shortcut
	 *
	 * 
	 */
	void (*unregister_shortcut)(struct wl_client *client,
				    struct wl_resource *resource,
				    uint32_t modifiers,
				    uint32_t keycode);
};

#define BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_SHORTCUT_PRESS 0

/**
 * @ingroup iface_budgie_keyboard_shortcuts_subscriber
 */
#define BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_SHORTCUT_PRESS_SINCE_VERSION 1

/**
 * @ingroup iface_budgie_keyboard_shortcuts_subscriber
 */
#define BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_budgie_keyboard_shortcuts_subscriber
 */
#define BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_REGISTER_SHORTCUT_SINCE_VERSION 1
/**
 * @ingroup iface_budgie_keyboard_shortcuts_subscriber
 */
#define BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_UNREGISTER_SHORTCUT_SINCE_VERSION 1

/**
 * @ingroup iface_budgie_keyboard_shortcuts_subscriber
 * Sends an shortcut_press event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
budgie_keyboard_shortcuts_subscriber_send_shortcut_press(struct wl_resource *resource_, uint32_t time_msec, uint32_t modifiers, uint32_t keycode)
{
	wl_resource_post_event(resource_, BUDGIE_KEYBOARD_SHORTCUTS_SUBSCRIBER_SHORTCUT_PRESS, time_msec, modifiers, keycode);
}

#ifdef  __cplusplus
}
#endif

#endif
